using System;
using System.Runtime.InteropServices;
using System.ComponentModel;

namespace OlInitializeSubjectExample
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("60E82434-7928-4ADC-870B-21B3422A9640"), ProgId("OlInitializeSubjectExample.AddinModule"), RunInstaller(true)]
    public class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
        public AddinModule()
        {
            InitializeComponent();
        }

		private AddinExpress.MSO.ADXOutlookAppEvents adxOutlookEvents;
 
        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;
 
        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
			this.components = new System.ComponentModel.Container();
			this.adxOutlookEvents = new AddinExpress.MSO.ADXOutlookAppEvents(this.components);
			// 
			// adxOutlookEvents
			// 
			this.adxOutlookEvents.InspectorActivate += new AddinExpress.MSO.ADXOlInspector_EventHandler(this.adxOutlookEvents_InspectorActivate);
			// 
			// AddinModule
			// 
			this.AddinName = "OlInitializeSubjectExample";
			this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook;
			this.OnSendMessage += new AddinExpress.MSO.ADXSendMessage_EventHandler(this.AddinModule_OnSendMessage);

		}
        #endregion
 
        #region Add-in Express automatic code
 
        // Required by Add-in Express - do not modify
        // the methods within this region
 
        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }
 
        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }
 
        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }
 
        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

		private const int WM_USER = 0x0400;
		private const int WM_MYMESSAGES = WM_USER + 1000;

		private void adxOutlookEvents_InspectorActivate(object sender, object inspector, string folderName)
		{
			object item = null;
			Outlook._Inspector insp = 
				inspector as Outlook._Inspector;

			try
			{
				item = insp.CurrentItem;
				if (item is Outlook._MailItem)
					this.SendMessage(WM_MYMESSAGES, IntPtr.Zero, IntPtr.Zero);
			}
			finally
			{
				if (item != null)
					Marshal.ReleaseComObject(item);
			}
		}

		private void AddinModule_OnSendMessage(object sender, AddinExpress.MSO.ADXSendMessageEventArgs e)
		{
			if (e.Message == WM_MYMESSAGES)
			{
				SetSubjectField();
			}
		}

        public Outlook._Application OutlookApp
        {
            get
            {
                return (HostApplication as Outlook._Application);
            }
        }

		private void SetSubjectField()
		{
			Outlook._MailItem mail = null;
			Outlook._Inspector insp = null;

			try
			{
				insp = OutlookApp.ActiveInspector();
				if (insp != null)
				{
					mail = insp.CurrentItem as Outlook.MailItem;
					if (mail.Subject == String.Empty || mail.Subject == null)
					{
						mail.Subject = "My Subject";
					}
				}
			}
			finally
			{
				if (mail != null)
					Marshal.ReleaseComObject(mail);
				if (insp != null)
					Marshal.ReleaseComObject(insp);
			}
		}
	}
}

